public class CompilationResult {

    private boolean ruleCompiledOk_;
    private String  compilationMsg_;

    public CompilationResult(boolean ruleCompiledOk, String compilationErrorMsg) {
        ruleCompiledOk_ = ruleCompiledOk;
        compilationMsg_ = compilationErrorMsg;
    }

    public boolean isRuleCompiledOk() {
        return ruleCompiledOk_;
    }

    public String getCompilationMsg() {
        return compilationMsg_;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((compilationMsg_ == null) ? 0 : compilationMsg_.hashCode());
        result = prime * result + (ruleCompiledOk_ ? 1231 : 1237);
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        CompilationResult other = (CompilationResult) obj;
        if (compilationMsg_ == null) {
            if (other.compilationMsg_ != null)
                return false;
        } else if (!compilationMsg_.equals(other.compilationMsg_))
            return false;
        if (ruleCompiledOk_ != other.ruleCompiledOk_)
            return false;
        return true;
    }

    @Override
    public String toString() {
        return "CompilationResult [ruleCompiledOk_=" + ruleCompiledOk_ + ", \ncompilationMsg_=" +
            compilationMsg_ + "]";
    }

}
