import java.util.List;
import java.util.Map;

import com.google.common.collect.Maps;

/*
 * I imagine this is a very fragile class
 */
public class ConsoleOutputScanner {

    public static String CHECKING_RULE_TOKEN = "checking rule";
    public static String PARSED_RULE_TOKEN   = "parsed rule";
    public static String TYPE_CHECKED_TOKEN  = "type checked rule";
    public static String ERROR_TOKEN         = "ERROR";
    public static String WARNING_TOKEN       = "WARNING";

    public static Map<String, CompilationResult> scanConsoleOutput(List<String> consoleOutLines,
            List<String> consoleErrLines) {

        Map<String, CompilationResult> results = Maps.newHashMap();

        System.out.println("Starting consoleOutputScan...");

        String currentRuleName = "";
        StringBuffer currentRuleMessage = new StringBuffer();
        boolean currentMessagePass = true;
        for (String line : consoleOutLines) {
            if (line.startsWith(CHECKING_RULE_TOKEN)) {
                // save current status as a CompileResult
                if (!currentRuleName.equals("")) {
                    CompilationResult compileResult = new CompilationResult(currentMessagePass,
                        currentRuleMessage.toString());
                    results.put(currentRuleName, compileResult);
                }
                // then move current to next rule
                currentRuleName = line.substring(CHECKING_RULE_TOKEN.length());
                currentRuleMessage = new StringBuffer();
                currentMessagePass = true;
            } else if (line.startsWith(ERROR_TOKEN) || line.startsWith(WARNING_TOKEN)) {
                currentMessagePass = false;
            }
            currentRuleMessage.append(line + "\n");
        }

        // not using error lines for now...but may be useful in future
        for (String line : consoleErrLines) {
            // System.out.println("ERR:" + line);
        }

        return results;
    }
}
